/* Strings and Characters */

let s = String()
let s1 = ""

s1.isEmpty

var s2 = s1 + "hello"

// String is value type
let s3 = s2

// Characters
let c:Character = "."
let c1 = "."


let age = 45
s2 = "My age is \(age)"
s2.characters.count


// String is Unicode compliant
//  1. String can use any character from any language
//  2. Under the hood, each character is represented with a unique 21-bit number (unicode scalar)

"\u{24}"
"\u{2665}"
"\u{1F496}"

"\u{65}"            // e
"\u{301}"           // acute accent

"\u{65}\u{301}"          // e followed by ́”
"\u{E9}"                         // é
// They are both a single character in Swift

if "\u{E9}" == "\u{65}\u{301}" {
   print("They are same")
}

"\u{65}\u{20DD}"          // e followed by ́”
"\u{65}\u{11AB}"          // e followed by ́”

"\u{41}"    // Latin letter A
"\u{410}"   // Russian letter A
if "\u{41}" != "\u{410}" {
   print("They are not same")
}

var str = "apple"
str.characters.count
str += "\u{20DD}"
str.characters.count
for scalar in str.unicodeScalars {
   print("\(scalar.value)")
}


var message = "hello world"
message.hasPrefix("hello")
message.hasSuffix("world ")
message.hasSuffix("worlD")






















